Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.

Bug 1910963

Summary: Review Request: python-EvoPreprocess - A Python Toolkit for Data Preprocessing with Evolutionary and Nature-Inspired Algorithms
Product: [Fedora] Fedora Reporter: Iztok Fister Jr. <iztok>
Component: Package ReviewAssignee: Aniket Pradhan <aniketpradhan1999>
Status: CLOSED RAWHIDE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: aniketpradhan1999, package-review, sanjay.ankur
Target Milestone: ---Flags: aniketpradhan1999: fedora-review+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: python-EvoPreprocess-0.3.4-1.fc34 Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2021-01-10 21:05:08 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On:    
Bug Blocks: 1276941    

Description Iztok Fister Jr. 2020-12-26 13:49:08 UTC
Spec URL: https://raw.githubusercontent.com/firefly-cpp/rpm-evopreprocess/main/python-EvoPreprocess.spec

SRPM URL: https://github.com/firefly-cpp/rpm-evopreprocess/raw/main/python-EvoPreprocess-0.3.2-1.fc33.src.rpm

Description: EvoPreprocess is a Python toolkit for sampling datasets, instance weighting, and feature selection. It is compatible with scikit-learn and imbalanced-learn. It is based on NiaPy library for the implementation 
of nature-inspired algorithms and is distributed under GNU General Public License v3.0 license.

Fedora Account System Username: iztokf

Comment 1 Aniket Pradhan 2020-12-30 09:54:07 UTC
Hey Iztok

Here's my review of the package.


* There's a small discrepancy in the upstream which is making the package not installable. This [0] line in the setup.py is missing a comma to separate out the requirements because of which the package cannot be installed:

```
Error: 
 Problem: conflicting requests
  - nothing provides python3.9dist(scikit-learnimbalanced-learnniapy) >= 2~rc11 needed by python3-EvoPreprocess-0.3.2-1.fc34.x86_64
```

[0]: https://github.com/karakatic/EvoPreprocess/blob/master/setup.py#L54

* Another small issue in the spec. You should be using the license short name instead of the full name in the License field. You can find the appropriate short name from here: https://fedoraproject.org/wiki/Licensing:Main

From what I can see, the correct short name should be `GPLv3`

* You misspelled "pypi" in this line:

```
%py_provides python3-%{pipy_name}
```

* Some small warnings about the line sizes from rpmlint. Please take care of that bit as well.

```
python3-EvoPreprocess.x86_64: E: summary-too-long C A Python Toolkit for Data Preprocessing with Evolutionary and Nature-Inspired Algorithms
python3-EvoPreprocess.x86_64: W: spelling-error %description -l en_US datasets -> data sets, data-sets, databases
python3-EvoPreprocess.x86_64: W: spelling-error %description -l en_US scikit -> sci kit, sci-kit, kitsch
python3-EvoPreprocess.x86_64: E: description-line-too-long C EvoPreprocess is a Python toolkit for sampling datasets, instance weighting, and feature selection.
python3-EvoPreprocess.x86_64: E: description-line-too-long C It is compatible with scikit-learn and imbalanced-learn. It is based on NiaPy library for the implementation
python3-EvoPreprocess.x86_64: E: description-line-too-long C of nature-inspired algorithms and is distributed under GNU General Public License v3.0 license.
python3-EvoPreprocess.x86_64: W: invalid-license GNU General Public License v3.0
python3-EvoPreprocess.x86_64: W: unexpanded-macro Provides python-%{pipy_name} = 0.3.2-1.fc34 %{pipy_name}
python3-EvoPreprocess.x86_64: W: unexpanded-macro Provides python3-%{pipy_name} = 0.3.2-1.fc34 %{pipy_name}
python3-EvoPreprocess.x86_64: W: unexpanded-macro Provides python3.9-%{pipy_name} = 0.3.2-1.fc34 %{pipy_name}
1 packages and 0 specfiles checked; 4 errors, 6 warnings.
```

Rest all seems fine, given there are no tests in the upstream for the package. Below's the review generated by fedora-review.



This is a review *template*. Besides handling the [ ]-marked tests you are
also supposed to fix the template before pasting into bugzilla:
- Add issues you find to the list of issues on top. If there isn't such
  a list, create one.
- Add your own remarks to the template checks.
- Add new lines marked [!] or [?] when you discover new things not
  listed by fedora-review.
- Change or remove any text in the template which is plain wrong. In this
  case you could also file a bug against fedora-review
- Remove the "[ ] Manual check required", you will not have any such lines
  in what you paste.
- Remove attachments which you deem not really useful (the rpmlint
  ones are mandatory, though)
- Remove this text



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "*No copyright* GNU General Public
     License, Version 3". 27 files have unknown license. Detailed output of
     licensecheck in
     /home/major/Documents/NeuroFedora/review/1910963-python-
     EvoPreprocess/licensecheck.txt
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[-]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[-]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: https://docs.fedoraproject.org/en-US/packaging-
     guidelines/#_use_rpmlint
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 2.8 starting (python version = 3.9.1, NVR = mock-2.8-1.fc33)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
INFO: Signal handler active
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled package manager cache
Start: cleaning package manager metadata
Finish: cleaning package manager metadata
INFO: enabled HW Info plugin
Mock Version: 2.8
INFO: Mock Version: 2.8
Finish: chroot init
INFO: installing package(s): /home/major/Documents/NeuroFedora/review/1910963-python-EvoPreprocess/results/python3-EvoPreprocess-0.3.2-1.fc34.x86_64.rpm
ERROR: Command failed: 
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-x86_64/root/ --releasever 34 --setopt=deltarpm=False --allowerasing --disableplugin=local --disableplugin=spacewalk install /home/major/Documents/NeuroFedora/review/1910963-python-EvoPreprocess/results/python3-EvoPreprocess-0.3.2-1.fc34.x86_64.rpm --setopt=tsflags=nocontexts



Rpmlint
-------
Checking: python3-EvoPreprocess-0.3.2-1.fc34.x86_64.rpm
          python-EvoPreprocess-0.3.2-1.fc34.src.rpm
python3-EvoPreprocess.x86_64: E: summary-too-long C A Python Toolkit for Data Preprocessing with Evolutionary and Nature-Inspired Algorithms
python3-EvoPreprocess.x86_64: W: spelling-error %description -l en_US datasets -> data sets, data-sets, databases
python3-EvoPreprocess.x86_64: W: spelling-error %description -l en_US scikit -> sci kit, sci-kit, kitsch
python3-EvoPreprocess.x86_64: E: description-line-too-long C EvoPreprocess is a Python toolkit for sampling datasets, instance weighting, and feature selection.
python3-EvoPreprocess.x86_64: E: description-line-too-long C It is compatible with scikit-learn and imbalanced-learn. It is based on NiaPy library for the implementation
python3-EvoPreprocess.x86_64: E: description-line-too-long C of nature-inspired algorithms and is distributed under GNU General Public License v3.0 license.
python3-EvoPreprocess.x86_64: W: invalid-license GNU General Public License v3.0
python3-EvoPreprocess.x86_64: W: unexpanded-macro Provides python-%{pipy_name} = 0.3.2-1.fc34 %{pipy_name}
python3-EvoPreprocess.x86_64: W: unexpanded-macro Provides python3-%{pipy_name} = 0.3.2-1.fc34 %{pipy_name}
python3-EvoPreprocess.x86_64: W: unexpanded-macro Provides python3.9-%{pipy_name} = 0.3.2-1.fc34 %{pipy_name}
python-EvoPreprocess.src: E: summary-too-long C A Python Toolkit for Data Preprocessing with Evolutionary and Nature-Inspired Algorithms
python-EvoPreprocess.src: W: spelling-error %description -l en_US datasets -> data sets, data-sets, databases
python-EvoPreprocess.src: W: spelling-error %description -l en_US scikit -> sci kit, sci-kit, kitsch
python-EvoPreprocess.src: E: description-line-too-long C EvoPreprocess is a Python toolkit for sampling datasets, instance weighting, and feature selection.
python-EvoPreprocess.src: E: description-line-too-long C It is compatible with scikit-learn and imbalanced-learn. It is based on NiaPy library for the implementation
python-EvoPreprocess.src: E: description-line-too-long C of nature-inspired algorithms and is distributed under GNU General Public License v3.0 license.
python-EvoPreprocess.src: W: invalid-license GNU General Public License v3.0
2 packages and 0 specfiles checked; 8 errors, 9 warnings.




Source checksums
----------------
https://github.com/karakatic/EvoPreprocess/archive/v0.3.2/EvoPreprocess-0.3.2.tar.gz :
  CHECKSUM(SHA256) this package     : 66c3eb11d463a4a46260d8b57721b9796f0c9b46cdd5cb37a999621dcad561a0
  CHECKSUM(SHA256) upstream package : 66c3eb11d463a4a46260d8b57721b9796f0c9b46cdd5cb37a999621dcad561a0


Requires
--------
python3-EvoPreprocess (rpmlib, GLIBC filtered):
    python(abi)
    python3.9dist(numpy)
    python3.9dist(scikit-learnimbalanced-learnniapy)
    python3.9dist(scipy)



Provides
--------
python3-EvoPreprocess:
    python-%{pipy_name}
    python-EvoPreprocess
    python3-%{pipy_name}
    python3-EvoPreprocess
    python3-EvoPreprocess(x86-64)
    python3.9-%{pipy_name}
    python3.9-EvoPreprocess
    python3.9dist(evopreprocess)
    python3dist(evopreprocess)



Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 1910963
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Python, Shell-api
Disabled plugins: R, Haskell, SugarActivity, Java, Perl, Ocaml, PHP, C/C++, fonts
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 2 Iztok Fister Jr. 2021-01-04 16:18:26 UTC
Hi Aniket,

Thank you very much for your comments.

Upstream has recently resolved problems with setup file. Other minor problems in SPEC were also fixed.

Revised version of my SPEC file is online on GH: https://github.com/firefly-cpp/rpm-evopreprocess

Thanks again.

Comment 3 Aniket Pradhan 2021-01-06 16:41:42 UTC
Hey!

The fixes look great. Approving the review.

Comment 4 Iztok Fister Jr. 2021-01-06 17:34:09 UTC
Thank you very much!

Comment 5 Gwyn Ciesla 2021-01-06 17:45:37 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-EvoPreprocess

Comment 6 Ankur Sinha (FranciscoD) 2021-01-11 09:28:13 UTC
Hello!

Awesome, another package! :D

I had a note or two:

- If the package is to be pushed to stable releases also, it's best to leave the bug open and then mention the review bug in the bodhi update. That way, as soon as the new packages go "stable" in bodhi, bodhi will close the bug for you.

- If the package is only being pushed to rawhide, we tend to add the first build to the "Fixed in version" field in the top right hand corner of the bug.  (I've done this now).

It's just for documentation so that others seeing the bug have all the information they need about what happened next. Without this info, they'll have to go to koji etc to find dig it up.

Cheers,
Ankur